// Memcpy.cpp : Defines the entry point for the console application.
//

#include <Windows.h>
#include <Winbase.h>
#include <tchar.h>
#include <stdio.h>
#include <intrin.h>
#pragma intrinsic(__rdtsc)
#pragma intrinsic(__movsd)
#pragma intrinsic(__movsq)

void * memcpy_amd(void *dest, const void *src, size_t n);

__inline __int64 ReadTimeStamp()
{
__asm rdtsc
}
/*timeOn = ReadTimeStamp(); 
timeOff = ReadTimeStamp();
-   96-104   Intel P4 HT 3.2 (    )
*/


#define PREFETCH_ON  1

int a = 16*1024;
int main(int argc, char* argv[])
{
    //printf("use:  len_dword, cash (0|1)");
    

int  size_all  = a;//1*32;
#define size_all2 16*1024*1024
unsigned long *buff1;
unsigned long *buff2;
unsigned long *buff3;
unsigned long *buff4;
unsigned long *buff5;
unsigned long *buff6;
unsigned long *buff7;
unsigned long *buff8;
__int64 timeOn,timeOff,Diff;
unsigned long ptimeOn,ptimeOff;

printf("param: length (byte)\n");
    if (argc>1)
        size_all = atoi(argv[1]);
    size_all = size_all & (~0x3);
    printf("\n"); //  !!!!     !
    if (size_all > 4096)
        printf("Process time switch?!?!? .\n"); //  !!!!     !
    printf("--------------------------\n"); //  !!!!     !

    //  ===================================================
    DWORD m_TickPerMkS;
    LARGE_INTEGER Freq;
    char text[256];
    if (QueryPerformanceFrequency(&Freq))
        m_TickPerMkS = (DWORD)(Freq.QuadPart * 0.000001);
    else
         GetLastError();

    if ( (Freq.QuadPart == (__int64)3579545) ||     
         (Freq.QuadPart == (__int64)1193182) )     //ACPI timer. || // 8253 timer
    {
        if (Freq.QuadPart == (__int64)1193182)
            printf("Used 8253-timer? 1 second testing...");
        else
            printf("Used ACPI timer? 1 second testing...");
        //       .
        //   HKLM\\Hardware\\Description\\System\\CentralProcessor\\0"
        //  :
        __int64   Time1;
        __int64   Time2;

        //LARGE_INTEGER frequency;
        //NtQueryPerformanceCounter( Time1, &frequency );


        SetProcessAffinityMask(GetCurrentProcess(),1);
        SetThreadAffinityMask(GetCurrentProcess(),1);
        SetPriorityClass(GetCurrentProcess(),REALTIME_PRIORITY_CLASS);
        Sleep(0);   //  
        Time1 = __rdtsc();    //   
        Sleep(1000);
        Time2 = __rdtsc();

        if (Time2 > Time1)
            m_TickPerMkS = DWORD( (Time2 - Time1)/1000000);
        else
            m_TickPerMkS = DWORD( (Time1 - Time2)/1000000);
    }
    else
        printf("Used RDTC timer. ");
    wsprintf(text,"Current Processor freq = %u MHz\n",m_TickPerMkS);
    printf(text);
    //  ===================================================



    buff1 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff2 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff3 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff4 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff5 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff6 = (unsigned long*)VirtualAlloc(NULL,size_all,MEM_COMMIT,PAGE_READWRITE);
    buff7 = (unsigned long*)VirtualAlloc(NULL,size_all2,MEM_COMMIT,PAGE_READWRITE);
    buff8 = (unsigned long*)VirtualAlloc(NULL,size_all2,MEM_COMMIT,PAGE_READWRITE);
    //buff1 = GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,size_all);
    //buff2 = GlobalAlloc(GMEM_FIXED|GMEM_ZEROINIT,size_all);

    ptimeOn = (DWORD)&timeOn;
    ptimeOff = (DWORD)&timeOff;
    
    //-----------------------------------    
    //     . 
    //  VirtualAlloc  4?   - !
    //  ???  .

    __movsd(buff1,buff2,size_all>>2);
    memcpy(buff5,buff6,size_all);
    memcpy_amd(buff3,buff4,size_all);

    __movsd(buff1,buff2,4>>2);
    memcpy(buff5,buff6,4);
    memcpy_amd(buff3,buff4,4);

    //  ? 
    memcpy_amd(buff7,buff8,size_all2);

    //-----------------------------------    
    Sleep(0);
    //===================================
    timeOn = ReadTimeStamp(); 
    //timeOff = __rdtsc(); -  
    /*__asm                -  .
    {
        rdtsc; // 64     edx:eax
        mov ecx,ptimeOn;
        mov [ecx], eax;
        mov [ecx+4], edx;        
    }*/

    __movsd(buff1,buff2,size_all>>2);
 
    timeOff = ReadTimeStamp();
    //-----------------------------------  
    if (timeOn < timeOff)
        Diff = timeOff - timeOn;
    else
        Diff = -1ULL - (timeOff - timeOn);

    printf("__movsd(,,%u>>2)  ",size_all);
    printf("Time = %I64d ticks \n",Diff);
    
    
    //-----------------------------------    
    Sleep(0);
    //===================================
    timeOn = ReadTimeStamp(); 

    memcpy(buff5,buff6,size_all);
 
    timeOff = ReadTimeStamp();
    //-----------------------------------  
    if (timeOn < timeOff)
        Diff = timeOff - timeOn;
    else
        Diff = -1ULL - (timeOff - timeOn);

    printf("memcpy(,,%u)      ",size_all);
    printf("Time = %I64d ticks \n",Diff);


    //-----------------------------------    
    Sleep(0);
    //===================================
    timeOn = ReadTimeStamp();

    memcpy_amd(buff3,buff4,size_all);

    timeOff = ReadTimeStamp();
    //-----------------------------------  
    if (timeOn < timeOff)
        Diff = timeOff - timeOn;
    else
        Diff = -1ULL - (timeOff - timeOn);
    printf("memcpy_amd(,,%u)  ",size_all);
    printf("Time = %I64d ticks \n",Diff);

    VirtualFree(buff1,size_all,MEM_RELEASE);
    VirtualFree(buff2,size_all,MEM_RELEASE);
    VirtualFree(buff3,size_all,MEM_RELEASE);
    VirtualFree(buff4,size_all,MEM_RELEASE);
    VirtualFree(buff5,size_all,MEM_RELEASE);
    VirtualFree(buff6,size_all,MEM_RELEASE);
    VirtualFree(buff7,size_all2,MEM_RELEASE);
    VirtualFree(buff8,size_all2,MEM_RELEASE);
    //GlobalFree(buff1);GlobalFree(buff2);
    return 0;
}

